"use strict";
/*
 * Due to the following Jest issue, GraphQL's `instanceof Error` test
 * cannot pass for Node assertions. So we have to define our own.
 *
 * https://github.com/facebook/jest/issues/2549
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.strictEqual = exports.ok = void 0;
/** Equivalent to `assert.ok(...)` */
function ok(val, message) {
    if (!val) {
        throw new Error(message);
    }
}
exports.ok = ok;
/** Equivalent to `assert.strictEqual(...)` */
function strictEqual(actual, expected, message) {
    if (actual !== expected) {
        throw new Error(message + ` (${actual} !== ${expected})`);
    }
}
exports.strictEqual = strictEqual;
//# sourceMappingURL=assert.js.map