import type { ExecutionDetails, GrafastResultsList, UnbatchedExecutionExtra } from "../interfaces.js";
import type { ExecutableStep } from "../step.js";
import { UnbatchedExecutableStep } from "../step.js";
export declare class FirstStep<TData> extends UnbatchedExecutableStep<TData> {
    static $$export: {
        moduleName: string;
        exportName: string;
    };
    isSyncAndSafe: boolean;
    allowMultipleOptimizations: boolean;
    constructor(parentPlan: ExecutableStep<ReadonlyArray<TData>>);
    execute({ indexMap, values: [values0], }: ExecutionDetails<[ReadonlyArray<TData>]>): GrafastResultsList<TData>;
    unbatchedExecute(_extra: UnbatchedExecutionExtra, list: any[]): any;
    deduplicate(peers: FirstStep<TData>[]): FirstStep<TData>[];
    optimize(): any;
}
/**
 * A plan that resolves to the first entry in the list returned by the given
 * plan.
 */
export declare function first<TData>(plan: ExecutableStep<ReadonlyArray<TData>>): FirstStep<TData>;
//# sourceMappingURL=first.d.ts.map