import type { GraphQLObjectType } from "graphql";
import type { AnyInputStep, NodeIdHandler, PolymorphicData, UnbatchedExecutionExtra } from "../interfaces.js";
import type { ExecutableStep, PolymorphicStep } from "../step.js";
import { UnbatchedExecutableStep } from "../step.js";
/**
 * A plan to get a Node by its global object identifier (string). Accepts an
 * object specifying the supported codecs, an object map detailing the
 * typeNames supported and their details (codec to use, how to find the record,
 * etc), and finally the Node id string plan.
 */
export declare class NodeStep extends UnbatchedExecutableStep implements PolymorphicStep {
    private possibleTypes;
    static $$export: {
        moduleName: string;
        exportName: string;
    };
    isSyncAndSafe: boolean;
    allowMultipleOptimizations: boolean;
    private specPlanDep;
    constructor(possibleTypes: {
        [typeName: string]: NodeIdHandler;
    }, $id: ExecutableStep<string | null | undefined>);
    planForType(type: GraphQLObjectType): ExecutableStep;
    private getTypeNameFromSpecifier;
    unbatchedExecute: (_extra: UnbatchedExecutionExtra, specifier: any) => PolymorphicData<string, ReadonlyArray<any>> | null;
}
/**
 * A plan to get a Node by its global object identifier (string). Accepts an
 * object specifying the supported codecs, an object map detailing the
 * typeNames supported and their details (codec to use, how to find the record,
 * etc), and finally the Node id string plan.
 */
export declare function node(possibleTypes: {
    [typeName: string]: NodeIdHandler;
}, $id: ExecutableStep<string | null | undefined>): NodeStep;
export declare function specFromNodeId(handler: NodeIdHandler<any>, $id: ExecutableStep<string> | AnyInputStep): any;
export declare function makeDecodeNodeId(handlers: NodeIdHandler[]): ($id: ExecutableStep<string | null | undefined>) => import("./lambda.js").LambdaStep<string | null | undefined, {
    [codecName: string]: any;
} | null>;
//# sourceMappingURL=node.d.ts.map