import type { GraphQLObjectType } from "graphql";
import type { ExecutionDetails, GrafastResultsList, PromiseOrDirect } from "../index.js";
import type { PolymorphicStep } from "../step.js";
import { ExecutableStep } from "../step.js";
type StepData<TStep extends ExecutableStep> = TStep extends ExecutableStep<infer U> ? U : any;
export interface PolymorphicBranchMatchers<TStep extends ExecutableStep> {
    [typeName: string]: PolymorphicBranchMatcher<TStep>;
}
export interface PolymorphicBranchMatcher<TStep extends ExecutableStep> {
    match?: (obj: StepData<TStep>) => boolean;
    plan?: ($obj: TStep) => ExecutableStep;
}
export declare class PolymorphicBranchStep<TStep extends ExecutableStep> extends ExecutableStep implements PolymorphicStep {
    static $$export: {
        moduleName: string;
        exportName: string;
    };
    isSyncAndSafe: boolean;
    private typeNames;
    private matchers;
    constructor($step: TStep, matchers: PolymorphicBranchMatchers<TStep>);
    planForType(objectType: GraphQLObjectType): ExecutableStep;
    execute({ indexMap, values: [values0], }: ExecutionDetails): PromiseOrDirect<GrafastResultsList<any>>;
}
export declare function polymorphicBranch<TStep extends ExecutableStep>($step: TStep, matchers: PolymorphicBranchMatchers<TStep>): PolymorphicBranchStep<TStep>;
export {};
//# sourceMappingURL=polymorphicBranch.d.ts.map