"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.reverse = exports.ReverseStep = exports.reverseArray = void 0;
const step_js_1 = require("../step.js");
/**
 * Returns a reversed copy of the list.
 */
function reverseArray(list) {
    if (!Array.isArray(list)) {
        throw new Error(`Attempted to reverse an array, but what was passed wasn't an array`);
    }
    const l = list.length;
    const newList = [];
    for (let i = 0; i < l; i++) {
        newList[i] = list[l - i - 1];
    }
    return newList;
}
exports.reverseArray = reverseArray;
/**
 * Reverses a list.
 */
class ReverseStep extends step_js_1.UnbatchedExecutableStep {
    static { this.$$export = {
        moduleName: "grafast",
        exportName: "ReverseStep",
    }; }
    constructor(plan) {
        super();
        this.isSyncAndSafe = true;
        this.allowMultipleOptimizations = true;
        this.addDependency(plan);
    }
    execute({ indexMap, values: [values0], }) {
        return indexMap((i) => {
            const arr = values0.at(i);
            return arr == null ? arr : reverseArray(arr);
        });
    }
    unbatchedExecute(_extra, arr) {
        return arr == null ? arr : reverseArray(arr);
    }
    deduplicate(peers) {
        return peers;
    }
}
exports.ReverseStep = ReverseStep;
/**
 * Reverses a list.
 */
function reverse(plan) {
    return new ReverseStep(plan);
}
exports.reverse = reverse;
//# sourceMappingURL=reverse.js.map