import type { PromiseOrDirect, UnbatchedExecutionExtra, UnwrapPlanTuple } from "../interfaces.js";
import type { ExecutableStep } from "../step.js";
import { UnbatchedExecutableStep } from "../step.js";
/**
 * Calls the given callback function for each tuple
 */
export declare class SideEffectStep<TIn, TOut> extends UnbatchedExecutableStep<TOut> {
    private fn;
    static $$export: {
        moduleName: string;
        exportName: string;
    };
    isSyncAndSafe: boolean;
    allowMultipleOptimizations: boolean;
    hasSideEffects: boolean;
    private planDep;
    constructor($plan: ExecutableStep<TIn> | null | undefined, fn: (value: TIn) => PromiseOrDirect<TOut>);
    toStringMeta(): any;
    unbatchedExecute(_extra: UnbatchedExecutionExtra, value: TIn): PromiseOrDirect<TOut>;
}
/**
 * A plan that takes the input `$plan` and feeds each value through the `fn`
 * callback. Note: if you need to pass more than one value, pass a `ListStep`
 * as the `$plan` argument.
 */
declare function sideEffect<const TIn extends readonly ExecutableStep[], TOut>(plans: TIn, fn: (value: UnwrapPlanTuple<TIn>) => PromiseOrDirect<TOut>): SideEffectStep<UnwrapPlanTuple<TIn>, TOut>;
declare function sideEffect<const TIn, TOut>($plan: ExecutableStep<TIn> | null | undefined, fn: (value: TIn) => PromiseOrDirect<TOut>): SideEffectStep<TIn, TOut>;
export { sideEffect };
//# sourceMappingURL=sideEffect.d.ts.map