"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.sideEffect = exports.SideEffectStep = void 0;
const step_js_1 = require("../step.js");
const list_js_1 = require("./list.js");
/**
 * Calls the given callback function for each tuple
 */
class SideEffectStep extends step_js_1.UnbatchedExecutableStep {
    static { this.$$export = {
        moduleName: "grafast",
        exportName: "SideEffectStep",
    }; }
    constructor($plan, fn) {
        super();
        this.fn = fn;
        this.isSyncAndSafe = false;
        this.allowMultipleOptimizations = false;
        this.hasSideEffects = true;
        this.planDep = $plan != null ? this.addDependency($plan) : null;
    }
    toStringMeta() {
        return this.fn.displayName || this.fn.name;
    }
    unbatchedExecute(_extra, value) {
        return this.fn(value);
    }
}
exports.SideEffectStep = SideEffectStep;
function sideEffect(planOrPlans, fn) {
    if (fn.length > 1) {
        throw new Error("sideEffect callback should accept one argument, perhaps you forgot to destructure the arguments?");
    }
    const $result = Array.isArray(planOrPlans)
        ? new SideEffectStep((0, list_js_1.list)(planOrPlans), fn)
        : new SideEffectStep(planOrPlans, fn);
    return $result;
}
exports.sideEffect = sideEffect;
//# sourceMappingURL=sideEffect.js.map